/******************************************************************************
** 
 * \file        main.c
 * \author      Jesus Martin Palomino Velazquez 
 *  
 *                PA1   -> SCL
 *                PA4   -> SDA
 *                GND   -> GND
 *                3.3V  -> VCC
 *  
******************************************************************************/

#include <stdio.h>
#include "wm_hal.h"
#include "gpio.h"

I2C_HandleTypeDef hi2c;

void Error_Handler(void);
static void I2C_Init(void);


void Write_Value_DAC(uint8_t dev_addr, uint16_t vout ){
	
	short int i=0; 
	uint8_t dato[3];
	
	dato[0] = 0x40; 
	dato[1] = (vout / 16);       // Upper data bits     (D11.D10.D9.D8.D7.D6.D5.D4)
    dato[2] = (vout % 16) << 4;  // Lower data bits     (D3.D2.D1.D0.x.x.x.x)
	
	I2C->DATA = dev_addr;    // enter the address into the data register MSP4725
	I2C->CR_SR = I2C_CR_WR | I2C_CR_START;  // turn on the module for transmission and emission
	while(I2C->CR_SR & I2C_SR_TIP){};// waiting for the end of the transfer
	
	for(i=0; i<=2; i++) {
		
		I2C->DATA = dato[i];  // enter the address of the register into the data register
        I2C->CR_SR = I2C_CR_WR ;        // send a byte
        while(I2C->CR_SR & I2C_SR_TIP){}; // waiting for the end of the transfer
	
    } 
      I2C->DATA = dev_addr+1;  //transfer the mcp4725 address  with a sign of reading
	  I2C->CR_SR = I2C_CR_WR | I2C_CR_START ; // pass a byte and restart to start reading
	  while(I2C->CR_SR & I2C_SR_TIP){}; // waiting for bus release
	  I2C->CR_SR = I2C_CR_RD |  I2C_CR_ACK | I2C_CR_STOP ; // receive a byte and immediately after it - NACK and STOP
	  while (I2C->CR_SR & I2C_SR_BUSY); // wait for bus release
	 // here you can assign the received byte to some variable by reading I2C->DATA
     // some_variable = I2C->DATA;
} 

	
int main(void)
{
	  uint16_t i=0;
	
	 SystemClock_Config(CPU_CLK_160M);
		
	   HAL_Init();
       GPIO_Init();
       I2C_Init();
  
	while (1){
		
      for(i=0; i<=4095; i=i+15){ 
	     Write_Value_DAC(0xC0, i);
		 HAL_Delay(600);
		 HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_1); 
	  }
    }
}


static void I2C_Init(void)

{
    hi2c.Instance = I2C;
    hi2c.Frequency = 400000;
    I2C_Init_Only_Write(&hi2c);

}

void Error_Handler(void)
{
   while (1){
  }
} 

void assert_failed(uint8_t *file, uint32_t line)
{
    printf("Wrong parameters value: file %s on line %d\r\n", file, line);
}